<?
/*
 * (C) Copyright 2003 Krzysztof Gibas <sdas (at) gibas org>
 *                      - current maintainer
 *               2001 Gonthar <gonthar (at) moon net pl>
 *                      - developed scr_ipfm-0.1
 *
 * scr_ipfm generates graphical statistics from ipfm logs. 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This  program is  distributed in the  hope  that  it will be useful,
 * but  WITHOUT  ANY  WARRANTY;  without even  the  implied warranty of
 * MERCHANTABILITY  or  FITNESS  FOR  A  PARTICULAR  PURPOSE.  See  the
 * GNU General Public License for more details.
 *
 * You  should  have  received a copy of the GNU General Public License
 * along  with  this  program;  if  not,  write  to  the  Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
 * USA.
 *
 * $Id: daily-graph.php,v 1.13 2003/11/13 09:05:57 gibas Exp $
 */


$sum_in = 0;
$sum_out = 0;
$sum_total = 0;

$in = 0;
$out = 0;
$total = 0;

//default values of variables.
secure_sort();
secure_flag();

$ar_years = create_ar_years();
$ar_months = create_ar_months();
$ar_days = create_ar_days();

secure_year();
secure_month();
secure_day();


$filename = "$ipfm_log_dir" . "ipfm-global-" . $_GET['year'] . "-" . $_GET['month'] . "-" . $_GET['day'] . ".log";

$header = "Graphical statistics for day " . $_GET['day'] . "-" . $_GET['month'] . "-" . $_GET['year'];

html_make_header_en($auto_refresh, $header, $version);

echo "<table class=\"tabletop\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\"><tbody><tr class=\"tabletop\"><td>";

html_make_links_year("dailygraph");
html_make_links_month("dailygraph");
html_make_links_day("dailygraph");

echo "</td></tr></tbody></table>";

html_make_links("daily");

check_dir_exists($ipfm_log_dir);
check_file_exists($filename, "day");

//sets global variables: $*_style, $s and $*_flag
set_style_flag_s();


//$_GET['flag'] = invert_flag($_GET['flag']);
echo "
<table class=\"makelinks\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\">
<tbody>
<tr>
    <td align=\"right\">$header</td>
</tr>
</tbody>
</table>";

html_make_links_graph();

echo "<br />";

//if($_GET['flag'] == "ASC") {
//    $datas = sortbycol(file($filename), $s, SORT_ASC);
//}
//else {
    $datas = sortbycol(file($filename), $s, SORT_DESC);
//}

echo "<table class=\"graph\"><tbody><tr><td>";

$string = "";
for($i = 0; $i < count($datas); $i++) {
    if(preg_match("/^# /", $datas[$i])) {
    
	if(strstr("$datas[$i]", " IPFM")) {
    	    //interface, time, version ipfm...
    	    $string = split(" ", $datas[$i]);
        
    	    //dirty hack - for old versions ipfm.
    	    if($string[6] == "every") {
        	$string[9] = $string[7];
        	$string[13] = $string[11];
    	    }
	}
    }     
    else {
	if(strlen($datas[$i]) != 0) {
            
            $elements = preg_split("/\s+/", $datas[$i]);
        
    	    $host = $elements[0];
    	    $total = $elements[$s];
            
            if (!isset($scale)) {
                $scale = calc_scale($datas[$i], $s);
            }

            //print "<BR><B>i: $i , scale: $scale , datas[i]: $datas[$i]</B><BR>";
            //print "total1: $total"; 
            $total_scaled = round($total) / round($scale);
	    
            //$style = set_table_bg_style($elements[$s]);
            //print "total2: $total_scaled";

            html_graph_horizon($host, $total, round($total_scaled));

	    /*
	    header('Content-Type: image/png');
	    
	    $im = @imagecreate (500, 22) or die ("Cannot Initialize new GD image stream");
    
	    $background_color = imagecolorallocate ($im, $_GET['r'],$_GET['g'],$_GET['b']);
	    $text_color = imagecolorallocate ($im, 0, 0, 0);
	    //3 - wielko
	    imagestring ($im, 3, 5, 5,  "A Simple Text String", $text_color);
    
	    //poziom - gra
	    imageline ($im, 0, 0, 500, 0, $text_color);
	    //poziom -d
	    imageline ($im, 0, 21, 500, 21, $text_color);
	    //pion - lewa
	    imageline ($im, 0, 0, 0, 21, $text_color);
	    //pion - prawa
	    imageline ($im, 499, 0, 499, 21, $text_color);
    
	    //imagepng ($im, "images/timg.png");

	    tempnam ("/tmp", "timg");
	    //echo "<img src=\"images/timg.png\" /><br />";
	    //unlink("images/timg.png");				    
	    imagepng ($im);
	    
	    imagedestroy ($im);
	    */
	    
	    //echo "$host - " . calc($total) . "<br />";
	    //echo "<img src=\"imagecreate.php?height=22&width=" . round($total_scaled) . "\" /><br />";

	}
    }
}

echo "</td></tr></tbody></table>";

html_make_empty_table();

html_make_version_table($string[1], $string[3], $string[9], $string[13], $version);
?>
